import * as React from 'react';
import 'requestidlecallback-polyfill';
interface Props extends React.ImgHTMLAttributes<HTMLImageElement> {
    offset?: number;
    transition?: string;
    fallback?: () => React.ReactNode;
    className?: string;
}
declare type State = {
    isVisible: boolean;
    isLoaded: boolean;
    opacity: number;
};
export default class Img extends React.Component<Props, State> {
    state: State;
    static defaultProps: {
        offset: number;
        transition: string;
        fallback: () => null;
    };
    ref: any;
    observer?: IntersectionObserver;
    idleCallbackId?: RequestIdleCallbackId;
    constructor(props: Props);
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    handleIntersection: IntersectionObserverCallback;
    handleTransitionEnd: () => void;
    render(): JSX.Element;
}
export {};
